<?php
/**
*
* @package Whatsapp Share
* @copyright (c) 2015 BruninoIt
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/
namespace bruninoit\washare\event;
/**
* @ignore
*/
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
/**
* Event listener
*/
class washare implements EventSubscriberInterface
{
	static public function getSubscribedEvents()
	{
		return array(
			'core.user_setup'						=> 'load_language',
			'core.viewtopic_modify_post_row'					=> 'share',
			'core.permissions'						=> 'permission_washare'
			);
	}
	/* @var \phpbb\template\template */
	protected $template;
	/** @var \phpbb\db\driver\driver_interface */
	protected $db;
	/** @var \phpbb\user */
	protected $user;
	protected $root_path;
	protected $phpEx;
	/** @var \phpbb\auth\auth */
	protected $auth;
    /** @var \phpbb\controller\helper */
    protected $controller_helper;
    protected $request;
	
	/**
	* Constructor
	*
	* @param \phpbb\controller\helper	$helper		Controller helper object
	* @param \phpbb\template			$template	Template object
	*/
	public function __construct(\phpbb\controller\helper $controller_helper, \phpbb\template\template $template, \phpbb\db\driver\driver_interface $db, \phpbb\user $user, $root_path, $phpEx, \phpbb\auth\auth $auth, \phpbb\request\request $request)	{
        $this->controller_helper = $controller_helper;
        $this->template = $template;
		$this->db = $db;
		$this->user = $user;
		$this->root_path = $root_path;
		$this->phpEx   = $phpEx;
		$this->auth = $auth;
      $this->request = $request;
      $this->max_char = 100; //limit of characters
	}
	

	public function permission_washare($event)
	{
	$permissions = $event['permissions'];
	$permissions['u_washare'] = array('lang' => 'ACL_U_WASHARE', 'cat' => 'misc');
	}
	
	public function load_language($event)
	{
		$lang_set_ext = $event['lang_set_ext'];
		$lang_set_ext[] = array(
			'ext_name' => 'bruninoit/washare',
			'lang_set' => 'common',
		);
		$event['lang_set_ext'] = $lang_set_ext;
	}
	public function share($event)
	{

$max_char=$this->max_char;


$rowmessage=$event['post_row'];
$title=$rowmessage['POST_SUBJECT'];
$text=$rowmessage['MESSAGE'];
$id=$rowmessage['POST_ID'];

//title
$title=strtoupper($title);

//text
$text=str_replace("<br />", "
", $text);
$text=strip_tags($text, "<br>");
//cut the text
if(strlen($text)>$max_char){
			$stringa_tagliata=substr($text, 0,$max_char);
			$last_space=strrpos($stringa_tagliata," ");
			$stringa_ok=substr($stringa_tagliata, 0,$last_space);
			$text=$stringa_ok."...";
		}

//url
$url=$this->request->server('SERVER_NAME', '');
$url.=$this->request->server('PHP_SELF', '');
$url.="?p=$id#p$id"; //$this->request->server('REQUEST_URI', '');
$url=str_replace("&amp;", "&", $url);
//$text=$this->newstring($text, $limit);

//final text
$continue = $this->user->lang['WASHARE_CONTINUE'];
$text="$title
\"$text\"";
$text.="

$continue: $url";
$text=rawurlencode($text);
   	if($this->auth->acl_get('u_washare'))
    {
		$this->template->assign_var('WASHARE', $text);
      $rowmessage['WASHARE']=$text;
      $event['post_row']=$rowmessage;
    }

    }

}

